

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.31. vector_find &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.32. vector_new" href="vector_new.html" />
    <link rel="prev" title="7.15.30. time_classify_year" href="time_classify_year.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/vector_find.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="vector_new.html" title="7.15.32. vector_new"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="time_classify_year.html" title="7.15.30. time_classify_year"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.31. </span><code class="docutils literal notranslate"><span class="pre">vector_find</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="vector-find">
<h1><span class="section-number">7.15.31. </span><code class="docutils literal notranslate"><span class="pre">vector_find</span></code><a class="headerlink" href="#vector-find" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.31.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 8.0.4.</span></p>
</div>
<p>It returns the first element that matches the given condition from the
given vector. If no element is found, it returns <code class="docutils literal notranslate"><span class="pre">null</span></code>.</p>
<p>You can use not only equal condition but also less than condition,
prefix equal condition and so on.</p>
<p>To enable this function, register <code class="docutils literal notranslate"><span class="pre">functions/vector</span></code> plugin by
the following command:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register functions/vector
</pre></div>
</div>
</div>
<div class="section" id="syntax">
<span id="vector-find-syntax"></span><h2><span class="section-number">7.15.31.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">vector_find</span></code> has two or three parameters:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>vector_find(vector, value)
vector_find(vector, value, mode)
</pre></div>
</div>
<p>If you omit the third argument, each element in the <code class="docutils literal notranslate"><span class="pre">vector</span></code> is
compared with <code class="docutils literal notranslate"><span class="pre">value</span></code> by equality comparison.</p>
</div>
<div class="section" id="usage">
<span id="vector-find-usage"></span><h2><span class="section-number">7.15.31.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>You need to register <code class="docutils literal notranslate"><span class="pre">functions/vector</span></code> plugin at first:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register functions/vector
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Here is a schema definition and sample data.</p>
<p>Sample schema:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create  Memos TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Memos tags COLUMN_VECTOR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Sample data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Memos
[
{&quot;_key&quot;: &quot;Groonga is fast&quot;,          &quot;tags&quot;: [&quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Mroonga is fast&quot;,          &quot;tags&quot;: [&quot;mroonga&quot;, &quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Groonga is very good!&quot;,    &quot;tags&quot;: [&quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Droonga is fast&quot;,          &quot;tags&quot;: [&quot;droonga&quot;, &quot;groonga&quot;]},
{&quot;_key&quot;: &quot;Groonga is a HTTP server&quot;, &quot;tags&quot;: [&quot;groonga&quot;, &quot;http&quot;]}
]
# [[0, 1337566253.89858, 0.000355720520019531], 5]
</pre></div>
</div>
<p>Here is a simple usage of <code class="docutils literal notranslate"><span class="pre">vector_find</span></code> that searches an element in
<code class="docutils literal notranslate"><span class="pre">tags</span></code> column and returns the first found element:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select \
  --table Memos \
  --output_columns &#39;tags, vector_find(tags, &quot;mroonga&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;tags&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;vector_find&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         null
#       ],
#       [
#         [
#           &quot;mroonga&quot;,
#           &quot;groonga&quot;
#         ],
#         &quot;mroonga&quot;
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         null
#       ],
#       [
#         [
#           &quot;droonga&quot;,
#           &quot;groonga&quot;
#         ],
#         null
#       ],
#       [
#         [
#           &quot;groonga&quot;,
#           &quot;http&quot;
#         ],
#         null
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>It returns <code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> when the <code class="docutils literal notranslate"><span class="pre">tags</span></code> column value includes
<code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> element. It returns <code class="docutils literal notranslate"><span class="pre">null</span></code> otherwise.</p>
<p>You can customize how to compare with each value by the third
argument. Here is a usage to use full text search to find an element:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select \
  --table Memos \
  --output_columns &#39;tags, vector_find(tags, &quot;roonga&quot;, &quot;@&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;tags&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;vector_find&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         &quot;groonga&quot;
#       ],
#       [
#         [
#           &quot;mroonga&quot;,
#           &quot;groonga&quot;
#         ],
#         &quot;mroonga&quot;
#       ],
#       [
#         [
#           &quot;groonga&quot;
#         ],
#         &quot;groonga&quot;
#       ],
#       [
#         [
#           &quot;droonga&quot;,
#           &quot;groonga&quot;
#         ],
#         &quot;droonga&quot;
#       ],
#       [
#         [
#           &quot;groonga&quot;,
#           &quot;http&quot;
#         ],
#         &quot;groonga&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>It returns <code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code>, <code class="docutils literal notranslate"><span class="pre">&quot;mroonga&quot;</span></code> or <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> when the
<code class="docutils literal notranslate"><span class="pre">tags</span></code> column value includes one of them. The returned value is the
first found element. For example, <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> is returned for
<code class="docutils literal notranslate"><span class="pre">[&quot;droonga&quot;,</span> <span class="pre">&quot;groonga&quot;]</span></code>. <code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code> isn’t returned because the
first element <code class="docutils literal notranslate"><span class="pre">&quot;droonga&quot;</span></code> is found before the second element
<code class="docutils literal notranslate"><span class="pre">&quot;groonga&quot;</span></code> is searched.</p>
<p>It returns <code class="docutils literal notranslate"><span class="pre">null</span></code> when <code class="docutils literal notranslate"><span class="pre">tags</span></code> column value doesn’t include them.</p>
</div>
<div class="section" id="parameters">
<span id="vector-find-parameters"></span><h2><span class="section-number">7.15.31.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>It requires two parameters.</p>
<p>There is an optional parameter.</p>
<div class="section" id="required-parameters">
<span id="vector-find-required-parameters"></span><h3><span class="section-number">7.15.31.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">vector</span></code> and <code class="docutils literal notranslate"><span class="pre">value</span></code> are required.</p>
<div class="section" id="vector">
<span id="vector-find-vector"></span><h4><span class="section-number">7.15.31.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">vector</span></code><a class="headerlink" href="#vector" title="Permalink to this headline">¶</a></h4>
<p>Specifies a vector value to be searched an element.</p>
</div>
<div class="section" id="value">
<span id="vector-find-value"></span><h4><span class="section-number">7.15.31.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">value</span></code><a class="headerlink" href="#value" title="Permalink to this headline">¶</a></h4>
<p>Specifies a value to be compared.</p>
</div>
</div>
<div class="section" id="optional-parameters">
<span id="vector-find-optional-parameters"></span><h3><span class="section-number">7.15.31.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">mode</span></code> is optional.</p>
<div class="section" id="mode">
<span id="vector-find-mode"></span><h4><span class="section-number">7.15.31.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">mode</span></code><a class="headerlink" href="#mode" title="Permalink to this headline">¶</a></h4>
<p>Specifies a mode that specifies how to compare each element with
<a class="reference internal" href="#vector-find-value"><span class="std std-ref">value</span></a>.</p>
<p>See <a class="reference internal" href="query.html#query-default-mode"><span class="std std-ref">default_mode</span></a> for available mode names. All mode names
except <code class="docutils literal notranslate"><span class="pre">&quot;NEAR&quot;</span></code>, <code class="docutils literal notranslate"><span class="pre">&quot;SIMILAR&quot;</span></code> and <code class="docutils literal notranslate"><span class="pre">&quot;SUFFIX&quot;</span></code> are supported.</p>
<p>The default mode is <code class="docutils literal notranslate"><span class="pre">&quot;EQUAL&quot;</span></code>. Note that <a class="reference internal" href="query.html#query-default-mode"><span class="std std-ref">default_mode</span></a>
says the default mode is <code class="docutils literal notranslate"><span class="pre">&quot;MATCH&quot;</span></code> but the default mode of
<code class="docutils literal notranslate"><span class="pre">vector_find</span></code> is <code class="docutils literal notranslate"><span class="pre">&quot;EQUAL&quot;</span></code>.</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.31.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>The matched element on match, <code class="docutils literal notranslate"><span class="pre">null</span></code> otherwise.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.31. <code class="docutils literal notranslate"><span class="pre">vector_find</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.31.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.31.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.31.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.31.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.15.31.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#vector">7.15.31.4.1.1. <code class="docutils literal notranslate"><span class="pre">vector</span></code></a></li>
<li><a class="reference internal" href="#value">7.15.31.4.1.2. <code class="docutils literal notranslate"><span class="pre">value</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.15.31.4.2. Optional parameters</a><ul>
<li><a class="reference internal" href="#mode">7.15.31.4.2.1. <code class="docutils literal notranslate"><span class="pre">mode</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.31.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="time_classify_year.html"
                        title="previous chapter"><span class="section-number">7.15.30. </span><code class="docutils literal notranslate"><span class="pre">time_classify_year</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="vector_new.html"
                        title="next chapter"><span class="section-number">7.15.32. </span><code class="docutils literal notranslate"><span class="pre">vector_new</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="vector_new.html" title="7.15.32. vector_new"
             >next</a> |</li>
        <li class="right" >
          <a href="time_classify_year.html" title="7.15.30. time_classify_year"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.31. </span><code class="docutils literal notranslate"><span class="pre">vector_find</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>